//
//  ViewController.swift
//  UDPTest
//
//  Created by Wei Xian Ong on 2020/12/2.
//  Copyright © 2020 Wei Xian Ong. All rights reserved.
//

import UIKit
import CocoaAsyncSocket

class ViewController: UIViewController, GCDAsyncUdpSocketDelegate {
    let ip = "255.255.255.255"
    var udpSocket: GCDAsyncUdpSocket!
    @IBOutlet weak var port: UITextField!
    @IBOutlet weak var massageTextView: UITextView!
    
    override func viewDidLoad() {
        super.viewDidLoad()
        // Do any additional setup after loading the view.
        udpSocket = GCDAsyncUdpSocket(delegate: self, delegateQueue: DispatchQueue.main)
    }

    @IBAction func bindPort(_ sender: Any) {
        do{
            try udpSocket.bind(toPort: UInt16(port.text!)!)
            showMassage(dateString())
            showMassage("已綁定端口\(UInt16(port.text!)!)")
            showMassage("---------------")
        }catch{
            showMassage("失敗")
        }
        do {
            try udpSocket.enableBroadcast(true)
            print("Broadcast")
        }catch{
            print("not able to broadcast")
        }
        do{
            try udpSocket.beginReceiving()
            print("Begin Receiving procceed")
        }catch{
            print("begin receiving not procceed")
        }
        view.endEditing(true)
        
    }
    
    func showMassage(_ str: String){
        massageTextView.text = massageTextView.text.appendingFormat("%@\n", str)
    }
    
    func dateString() -> String{
        let now = Date()
        let dateFormatter = DateFormatter()
        dateFormatter.dateFormat = "yyyy-MM-dd HH:mm:ss"
        let date = dateFormatter.string(from: now)
        return date
    }
    
    
}

